! At the moment this is a hard-coded file and not extracted from
! omegalib.nw
!
! Copyright (C) 2000-2004 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
module omega_parameters_littlest
  use omega_kinds
  use omega_constants
  implicit none
  private
  public :: setup_parameters, print_parameters
  real(kind=omega_prec), dimension(45), save, public :: mass = 0, width = 0
  real(kind=omega_prec), parameter, public :: GeV = 1.0_double
  real(kind=omega_prec), parameter, public :: MeV = GeV / 1000
  real(kind=omega_prec), parameter, public :: keV = MeV / 1000
  real(kind=omega_prec), parameter, public :: TeV = GeV * 1000
  real(kind=omega_prec), save, public :: &
       alpha = 1.0_double / 137.0359895_double, &
       sin2thw = 0.23124_double
  complex(kind=omega_prec), save, private :: vev
  complex(kind=omega_prec), save, public :: &
       qlep = 0, qup = 0, qdwn = 0, gcc = 0, qw = 0, &
       gzww = 0, gwww = 0, ghww = 0, ghhww = 0, ghzz = 0, ghhzz = 0, &
       ghbb = 0, ghtt = 0, ghcc = 0, ghtautau = 0, gh3 = 0, gh4 = 0, &
       ghgaga = 0, ghgaz = 0, &
       iqw = 0, igzww = 0, igwww = 0, &
       gw4 = 0, gzzww = 0, gazww = 0, gaaww = 0, &
       gs = 0, igs = 0
  complex(kind=omega_prec), save, public :: &
       sinckm12 = 0, sinckm13 = 0, sinckm23 = 0, &
       cosckm12 = 0, cosckm13 = 0, cosckm23 = 0
  complex(kind=omega_prec), save, public :: &
       vckm_11 = 0, vckm_12 = 0, vckm_13 = 0, vckm_21 = 0, &
       vckm_22 = 0, vckm_23 = 0, vckm_31 = 0, vckm_32 = 0, vckm_33 = 0
  complex(kind=omega_prec), save, public :: &
       gccq11 = 0, gccq12 = 0, gccq13 = 0, gccq21 = 0, &
       gccq22 = 0, gccq23 = 0, gccq31 = 0, gccq32 = 0, gccq33 = 0       
  real(kind=omega_prec), save, public :: &
       g1a = 1, g1z = 1, kappaa = 1, kappaz = 1, lambdaa = 0, lambdaz = 0, &
       g4a = 0, g4z = 0, g5a = 0, g5z = 0, &
       kappa5a = 0, kappa5z = 0, lambda5a = 0, lambda5z = 0, &
       alpha4 = 0, alpha5 = 0, tau4 = 0, tau5 = 0
  real(kind=omega_prec), save, public :: xia = 1, xi0 = 1, xipm = 1
  complex(kind=omega_prec), dimension(2), save, public :: &
       gnclep = 0, gncneu = 0, gncup = 0, gncdwn = 0
  complex(kind=omega_prec), save, public :: &
       fudge_o1 = 1, fudge_o2 = 1, fudge_o3 = 1, fudge_o4 = 1
  complex(kind=omega_prec), save, public :: &
       ghmumu = 0
  complex(kind=omega_prec), save, public :: &
       gh0ww = 0, gh0zz = 0, &
       gh0tt = 0, gh0bb = 0, gh0cc = 0, gh0tautau = 0, gh0mumu = 0, &
       iga0tt = 0, iga0bb = 0, iga0cc = 0, iga0tautau = 0, iga0mumu = 0, &
       gahh = 0, gzhh = 0, igzha = 0, igzh0a = 0
  complex(kind=omega_prec), dimension(2), save, public :: &
       ghptb = 0, ghpcs = 0, ghptaunu = 0, ghpmunu = 0
  !!! Additional Littlest Higgs parameters 
  complex(kind=omega_prec), save, public :: &
       ghwhw = 0, ghwhwh = 0, ghahah = 0, ghzhz = 0, ghzhah = 0, &
       ghahz = 0, ghaa = 0, ghgg = 0, geaa = 0, geaz = 0, gegg = 0
  complex(kind=omega_prec), save, public :: & 
       gpsiww = 0, gpsiwhw = 0, gpsizz = 0, gpsizhzh = 0, & 
       gpsizhz = 0, gpsizah = 0, gpsizhah = 0, gpsiahah = 0, & 
       gpsizw = 0, gpsizwh = 0, gpsiahw = 0, gpsiahwh = 0, &
       gpsizhw = 0, gpsizhwh = 0, gpsippww = 0, gpsippwhw = 0, &
       gpsippwhwh = 0, gpsihw = 0, gpsihwh = 0, gpsi0w = 0, & 
       gpsi0wh = 0, gpsi1w = 0, gpsi1wh = 0, gpsippw = 0, &
       gpsippwh = 0
  complex(kind=omega_prec), save, public :: & 
       gpsihah = 0, gpsi0ah = 0, gahpsip = 0, &
       gpsi1hz = 0, gpsi1hzh = 0, gpsi01z = 0, gpsi01zh = 0, &
       gzpsip = 0, gzpsipp = 0, gzhpsipp = 0
  complex(kind=omega_prec), save, public :: &
       ghhaa = 0, ghhwhw = 0, ghhzhz = 0, ghhahz = 0, ghhzhah = 0, &
       ghpsi0ww = 0, ghpsi0whw = 0, ghpsi0zz = 0, ghpsi0zhzh = 0, & 
       ghpsi0zhz = 0, ghpsi0ahah = 0, ghpsi0zah = 0, ghpsi0zhah = 0
  complex(kind=omega_prec), save, public :: &
      ghpsipwa = 0, ghpsipwha = 0, ghpsipwz = 0, ghpsiwhz = 0, &
      ghpsipwah = 0, ghpsipwhah = 0, ghpsipwzh = 0, ghpsipwhzh = 0, & 
      ghpsippww = 0, ghpsippwhwh = 0, ghpsippwhw = 0, gpsi00zh = 0, &
      gpsi00ah = 0, gpsi00zhah = 0, gpsi0pwa = 0, gpsi0pwha = 0, & 
      gpsi0pwz = 0, gpsi0pwhz = 0, gpsi0pwah = 0, gpsi0pwhah = 0, & 
      gpsi0pwzh = 0, gpsi0pwhzh = 0, gpsi0ppww = 0, gpsi0ppwhwh = 0, &
      gpsi0ppwhw = 0, i_gpsi0pwa = 0, i_gpsi0pwha = 0, & 
      i_gpsi0pwz = 0, i_gpsi0pwhz = 0, i_gpsi0pwah = 0, i_gpsi0pwhah = 0, & 
      i_gpsi0pwzh = 0, i_gpsi0pwhzh = 0, i_gpsi0ppww = 0, i_gpsi0ppwhwh = 0, &
      i_gpsi0ppwhw = 0
  complex(kind=omega_prec), save, public :: & 
      gpsippzz = 0, gpsippzhzh = 0, gpsippaz = 0, gpsippaah = 0, & 
      gpsippzah = 0, gpsippwa = 0, gpsippwha = 0, gpsippwz = 0, &
      gpsippwhz = 0, gpsippwah = 0, gpsippwhah = 0, gpsippwzh = 0, &
      gpsippwhzh = 0, gpsicczz = 0, gpsiccaz = 0, gpsiccaah = 0, &
      gpsicczzh = 0, gpsiccazh = 0, gpsicczah = 0
  complex(kind=omega_prec), save, public :: &
      igahww = 0, igzhww = 0, igzwhw = 0, igahwhwh = 0, igzhwhwh = 0, &
      igahwhw = 0
  complex(kind=omega_prec), save, public :: &
      gwh4 = 0, gwhwhww = 0, gwhwww = 0, gwh3w = 0, gwwaah = 0, &
      gwwazh = 0, gwwzzh = 0, gwwzah = 0, gwhwhaah = 0, gwhwhazh = 0, &
      gwhwhzzh = 0, gwhwhzah = 0, gwwzhah = 0, gwhwhzhah = 0, &
      gwhwzz = 0, gwhwaz = 0, gwhwaah = 0, gwhwzah = 0, gwhwzhzh = 0, &
      gwhwzhah = 0, gwhwazh = 0, gwhwzzh = 0
  complex(kind=omega_prec), save, public :: &
      qzup = 0, gcch = 0, gcctop = 0, gccw = 0, gccwh = 0, &
      gnch = 0, gztht = 0, gzhtht = 0, gah = 0
  complex(kind=omega_prec), dimension(2), save, public :: &
      gnchup = 0, gnchdwn = 0, gnchneu = 0, gnchlep = 0, gahtt = 0, &
      gahthth = 0, ghtht = 0, gpsipq2 = 0, gpsipq3 = 0, &
      ghhtht = 0
  complex(kind=omega_prec), save, public :: &
      gahtht = 0, ghthth = 0, &
      gpsi0tt = 0, gpsi0bb = 0, gpsi0cc = 0, gpsi0tautau = 0, &
      gpsipl3 = 0, gpsi0tth = 0, gpsi1tth = 0, gpsipbth = 0, &
      ghhtt = 0, ghhthth = 0
contains
  subroutine setup_parameters ()
    real(kind=omega_prec) :: e, g, sinthw, costhw, qelep, qeup, qedwn
    real(kind=omega_prec) :: sinth, costh, sinthp, costhp, &
         sin2th, cos2th, sin2thp, cos2thp 
    real(kind=omega_prec) :: t_fac, tp_fac
    mass(1) =   5.0 * MeV
    mass(2) =   3.0 * MeV
    mass(3) = 100.0 * MeV
    mass(4) =   1.2 * GeV
    mass(5) =   4.2 * GeV
    mass(6) = 174.0 * GeV
    width(1:5) = 0
    width(6) =  1.3 * GeV
    mass(11) =    0.51099907 * MeV
    mass(12) =    0
    mass(13) =  105.658389 * MeV
    mass(14) =    0
    mass(15) = 1777.05 * MeV
    mass(16) =    0
    width(11:16) = 0
    mass(21) =  0
    mass(22) =  0
    width(21:22) = 0
    mass(23) =  91.187 * GeV
    width(23) =  2.490 * GeV
    mass(24) =  80.41 * GeV
    width(24) =  2.06 * GeV
    mass(25) = 120.00 * GeV
    width(25) =  5.00 * GeV
    mass(35) = 10000 * GeV
    width(35) =  0
    sinckm12 = 0.0_omega_prec
    sinckm13 = 0.0_omega_prec
    sinckm23 = 0.0_omega_prec
    cosckm12 = sqrt ((1.0_omega_prec - (sinckm12**2)))
    cosckm13 = sqrt ((1.0_omega_prec - (sinckm13**2)))
    cosckm23 = sqrt ((1.0_omega_prec - (sinckm23**2)))
    mass(26) =  xi0 * mass(23)
    width(26) =  0
    mass(27) =  xipm * mass(24)
    width(27) =  0
    e = sqrt (4 * PI * alpha)
    qelep = - 1
    qeup = 2.0_omega_prec / 3.0_omega_prec
    qedwn = - 1.0_omega_prec / 3.0_omega_prec
    sinthw = sqrt (sin2thw)
    costhw = sqrt (1 - sin2thw)
    g = e / sinthw
    gcc = - g / 2 / sqrt (2.0_double)
    vckm_11 = cosckm12 * cosckm13
    vckm_12 = sinckm12 * cosckm13
    vckm_13 = sinckm13 
    vckm_21 =  - (sinckm12 * cosckm23 +  &
      cosckm12 * sinckm23 * sinckm13)
    vckm_22 = cosckm12 * cosckm23 -  &
      sinckm12 * sinckm23 * sinckm13
    vckm_23 = sinckm23 * cosckm13
    vckm_31 = sinckm12 * sinckm23 -  &
      cosckm12 * cosckm23 * sinckm13
    vckm_32 = - (cosckm12 * sinckm23 +  &
      sinckm12 * cosckm23 * sinckm13)
    vckm_33 = cosckm23 * cosckm13
    gccq11 = gcc * vckm_11
    gccq12 = gcc * vckm_12
    gccq13 = gcc * vckm_13
    gccq21 = gcc * vckm_21
    gccq22 = gcc * vckm_22
    gccq23 = gcc * vckm_23
    gccq31 = gcc * vckm_31
    gccq32 = gcc * vckm_32
    gccq33 = gcc * vckm_33
    gncneu(1) = - g / 2 / costhw * ( + 0.5_double)
    gnclep(1) = - g / 2 / costhw * ( - 0.5_double - 2 * qelep * sin2thw)
    gncup(1)  = - g / 2 / costhw * ( + 0.5_double - 2 * qeup  * sin2thw)
    gncdwn(1) = - g / 2 / costhw * ( - 0.5_double - 2 * qedwn * sin2thw)
    gncneu(2) = - g / 2 / costhw * ( + 0.5_double)
    gnclep(2) = - g / 2 / costhw * ( - 0.5_double)
    gncup(2)  = - g / 2 / costhw * ( + 0.5_double)
    gncdwn(2) = - g / 2 / costhw * ( - 0.5_double)
    qlep = - e * qelep
    qup = - e * qeup
    qdwn = - e * qedwn
    qw = e
    iqw = (0,1)*qw
    gzww = g * costhw
    igzww = (0,1)*gzww
    gwww = g
    igwww = (0,1)*gwww
    ghww = mass(24) * g
    ghhww = g**2 / 2.0_omega_prec
    ghzz = mass(23) * g / costhw
    ghhzz = g**2 / 2.0_omega_prec / costhw**2
    gw4 = g**2
    gzzww = gzww**2
    gazww = gzww*e
    gaaww = e**2
    vev = 2.0 * mass(24) / g
    ghtt = - mass(6) / vev
    ghbb = - mass(5) / vev
    ghcc = - mass(4) / vev
    ghtautau = - mass(15) / vev
    gh3 = - 3 * mass(25)**2 / vev
    gh4 = - 3 * mass(25)**2 / vev**2
    !!! Littlest Higgs specific couplings
    sin2th = sinth**2
    cos2th = 1.0_omega_prec - sin2th
    costh = sqrt(cos2th)
    sin2thp = sinthp**2
    cos2thp = 1.0_omega_prec - sin2thp
    costhp = sqrt(cos2thp)
    t_fac = (cos2th - sin2th)/2.0_omega_prec/sinth/costh
    tp_fac = (cos2thp - sin2thp)/2.0_omega_prec/sinthp/costhp
  end subroutine setup_parameters
  subroutine print_parameters ()
    print *, "Quark masses:"
    print *, mass(2:6:2)
    print *, mass(1:5:2)
    print *, "Lepton masses:"
    print *, mass(12:16:2)
    print *, mass(11:15:2)
    print *, "Quark widths:"
    print *, width(2:6:2)
    print *, width(1:5:2)
    print *, "Lepton widths:"
    print *, width(12:16:2)
    print *, width(11:15:2)
    print *, "SU(2)xU(1) Gauge boson masses/widths:"
    print *, mass(22:24)
    print *, width(22:24)
    print *, "Higgs boson and gluon masses/widths:"
    print *, mass(25), mass(21)
    print *, width(25), width(21) 
    print *, "Neutral current couplings:"
    print *, "U:", gncup
    print *, "D:", gncdwn
    print *, "N:", gncneu
    print *, "L:", gnclep
    print *, "Fermion charges:"
    print *, "U:", qup
    print *, "D:", qdwn
    print *, "L:", qlep
    print *, "TGC:"
    print *, "WWA:", iqw
    print *, "WWZ:", igzww
    print *, "WWW:", igwww
    print *, "WWH:", ghww
    !!! print *, "WWHH:", ghhww**2 !!! Old SM3
    print *, "WWHH:", ghhww
    !!! print *, "ZZHH:", ghhzz**2 !!! Old SM3
    print *, "ZZHH:", ghhzz       
  end subroutine print_parameters
end module omega_parameters_littlest
